/* qmrecentfiles.h
 *
 * $Id$
 *
 * Apollo sound player: http://www.apolloplayer.org
 * Copyright(C) 2000-2002 Apollo Team.  See CREDITS file.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * The GNU General Public License is also available online at:
 *
 * http://www.gnu.org/copyleft/gpl.html
 */

#ifndef QMRECENTFILES_H_INCLUDED
#define QMRECENTFILES_H_INCLUDED

#include "qmautoptr.h"
#include "qmmainwindow.h"
#include "qmconfig.h"

#include <qstringlist.h>
#include <qstring.h>
#include <qpopupmenu.h>
#include <qobject.h>


class QmRecentFiles : public QObject
{
	Q_OBJECT
	
public:
	~QmRecentFiles();
	static QmRecentFiles *instance();

	void addPlayList(const QString &name);
	void addPlayListTree(const QString &name);
	void save();
	void load();
	QPopupMenu *menu() { return m_pMenu; }

protected:
	void updateMenu();

protected slots:
    void clicked(int menuIndex);

private:
	QmRecentFiles();
	void add(const QString &name, QStringList *to, unsigned int max);
	QStringList m_PlayLists;
	QStringList m_PlayListTrees;
	QPopupMenu *m_pMenu;

	static QmAutoPtr<QmRecentFiles> s_pInstance;
};

#endif
